@echo off

REM ##### 初期設定 #####
set SERVER_MODE=1
set SERVER_ADMIN=webmaster@localhost
set SERVER_DOMAIN=localhost
set SERVER_NAME=localhost
set LOOP_NUM=12

REM ##### 引数取得 #####
set SRC_DIR=%~1
set INSTALLER_FILENAME=%~2
set INSTALL_DIR=%~3
set SERVICE_NAME=%~4

REM ##### 初期処理 #####
if NOT "%SRC_DIR:~-1%" == "\" (
	set SRC_DIR=%SRC_DIR%\
)

REM ##### インストール #####
start /wait msiexec.exe /q /i "%SRC_DIR%%INSTALLER_FILENAME%" INSTALLDIR="%INSTALL_DIR%" ALLUSERS=%SERVER_MODE% SERVERADMIN=%SERVER_ADMIN% SERVERDOMAIN=%SERVER_DOMAIN% SERVERNAME=%SERVER_NAME% SERVICENAME="%SERVICE_NAME%"

REM ##### Apache停止を試みる #####
for /l %%i in (1,1,%LOOP_NUM%) do (
	ping localhost -n 5 > nul
	"%INSTALL_DIR%\bin\httpd.exe" -k stop -n "%SERVICE_NAME%" 1>nul 2>nul
	if errorlevel 1 (
		if "%%i" == "%LOOP_NUM%" (
			echo Apacheの停止に失敗しました。
			goto end
		)
		echo Apacheの停止に失敗しましたためリトライします。^(%%i^)
	) else (
		echo Apacheを停止しました。
		goto end
	)
)
:end
